/*
The MIT License (MIT)

Copyright (c) 2015 Jan Peter Simonsen

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:


The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.


THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.


License for the Original TypeScript code (found here https://github.com/SBCGames/Spriter-Player-for-Phaser/blob/master/license.txt) that is the basis:

The MIT License (MIT)

Copyright (c) 2015 Tomas Rychnovsky


Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:


The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.


THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
var Spriter;
(function (Spriter_1) {
    var Spriter = (function () {
        // -------------------------------------------------------------------------
        function Spriter() {
            this._folders = new Helper.IdNameMap();
            this._entities = new Helper.IdNameMap();
        }
        // -------------------------------------------------------------------------
        Spriter.prototype.addFolder = function (aFolder) {
            this._folders.add(aFolder, aFolder.getId(), aFolder.getName());
        };
        // -------------------------------------------------------------------------
        Spriter.prototype.getFolderById = function (aId) {
            return this._folders.getById(aId);
        };
        // -------------------------------------------------------------------------
        Spriter.prototype.getFolderByName = function (aName) {
            return this._folders.getByName(aName);
        };
        // -------------------------------------------------------------------------
        Spriter.prototype.addEntity = function (aEntitiy) {
            this._entities.add(aEntitiy, aEntitiy.getId(), aEntitiy.getName());
        };
        // -------------------------------------------------------------------------
        Spriter.prototype.getEntityById = function (aId) {
            return this._entities.getById(aId);
        };
        // -------------------------------------------------------------------------
        Spriter.prototype.getEntityByName = function (aName) {
            return this._entities.getByName(aName);
        };
        return Spriter;
    })();
    Spriter_1.Spriter = Spriter;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=Spriter.js.map
///<reference path="CurveType.ts"/>
var Spriter;
(function (Spriter) {
    var TimelineKey = (function () {
        // -------------------------------------------------------------------------
        function TimelineKey(aId, aTime, aSpin) {
            this._id = aId;
            this._time = aTime;
            this._spin = aSpin;
            this.setCurve(Spriter.eCurveType.LINEAR);
        }
        TimelineKey.prototype.setCurveType = function (value) {
            this._curveType = value;
        };
        // -------------------------------------------------------------------------
        TimelineKey.prototype.setCurve = function (aCurveType, aC1, aC2, aC3, aC4) {
            if (aC1 === void 0) { aC1 = 0; }
            if (aC2 === void 0) { aC2 = 0; }
            if (aC3 === void 0) { aC3 = 0; }
            if (aC4 === void 0) { aC4 = 0; }
            this._curveType = aCurveType;
            this._c1 = aC1;
            this._c2 = aC2;
            this._c3 = aC3;
            this._c4 = aC4;
        };
        // -------------------------------------------------------------------------
        TimelineKey.prototype.getId = function () {
            return this._id;
        };
        // -------------------------------------------------------------------------
        TimelineKey.prototype.getTime = function () {
            return this._time;
        };
        // -------------------------------------------------------------------------
        TimelineKey.prototype.getSpin = function () {
            return this._spin;
        };
        // -------------------------------------------------------------------------
        TimelineKey.prototype.getCurveType = function () {
            return this._curveType;
        };
        // -------------------------------------------------------------------------
        TimelineKey.prototype.getC1 = function () {
            return this._c1;
        };
        // -------------------------------------------------------------------------
        TimelineKey.prototype.getC2 = function () {
            return this._c2;
        };
        // -------------------------------------------------------------------------
        TimelineKey.prototype.getC3 = function () {
            return this._c3;
        };
        // -------------------------------------------------------------------------
        TimelineKey.prototype.getC4 = function () {
            return this._c4;
        };
        return TimelineKey;
    })();
    Spriter.TimelineKey = TimelineKey;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=TimelineKey.js.map
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
///<reference path="SpatialInfo.ts"/>
///<reference path="TimelineKey.ts"/>
var Spriter;
(function (Spriter) {
    var SpatialTimelineKey = (function (_super) {
        __extends(SpatialTimelineKey, _super);
        function SpatialTimelineKey() {
            _super.apply(this, arguments);
            this._info = new Spriter.SpatialInfo();
        }
        // -------------------------------------------------------------------------
        SpatialTimelineKey.prototype.getInfo = function () {
            return this._info;
        };
        return SpatialTimelineKey;
    })(Spriter.TimelineKey);
    Spriter.SpatialTimelineKey = SpatialTimelineKey;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=SpatialTimelineKey.js.map
///<reference path="Game.ts"/>
var SpriterExample;
(function (SpriterExample) {
    var Global = (function () {
        function Global() {
        }
        // game derived from Phaser.Game
        Global.game = null;
        // game size
        Global.GAME_WIDTH = 1024;
        Global.GAME_HEIGHT = 768;
        // assets path
        Global.assetsPath = "assets/";
        return Global;
    })();
    SpriterExample.Global = Global;
})(SpriterExample || (SpriterExample = {}));
var PhaserGlobal = {
    stopFocus: true
};
// -------------------------------------------------------------------------
window.onload = function () {
    SpriterExample.Global.game = new SpriterExample.Game();
};
//# sourceMappingURL=App.js.map
///<reference path="../lib/phaser.d.ts"/>
///<reference path="app.ts"/>
///<reference path="States/Boot.ts"/>
///<reference path="States/Preloader.ts"/>
///<reference path="States/Test.ts"/>
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var SpriterExample;
(function (SpriterExample) {
    var Game = (function (_super) {
        __extends(Game, _super);
        // -------------------------------------------------------------------------
        function Game() {
            Game.game = this;
            // init game
            _super.call(this, SpriterExample.Global.GAME_WIDTH, SpriterExample.Global.GAME_HEIGHT, Phaser.AUTO, "content", null /* , transparent, antialias, physicsConfig */);
            // states
            this.state.add("Boot", SpriterExample.Boot);
            this.state.add("Preloader", SpriterExample.Preloader);
            this.state.add("Test", SpriterExample.Test);
            // start
            this.state.start("Boot");
        }
        return Game;
    })(Phaser.Game);
    SpriterExample.Game = Game;
})(SpriterExample || (SpriterExample = {}));
//# sourceMappingURL=Game.js.map
var Helper;
(function (Helper) {
    var IdNameMap = (function () {
        function IdNameMap() {
            this._items = [];
            this._itemNames = [];
        }
        // -------------------------------------------------------------------------
        IdNameMap.prototype.add = function (aItem, aId, aName) {
            if (aId === undefined) {
                aId = this._items.length;
            }
            if (aName === undefined || aName === null) {
                aName = "item_" + aId;
            }
            this._items[aId] = aItem;
            this._itemNames[aName] = aId;
        };
        // -------------------------------------------------------------------------
        IdNameMap.prototype.getById = function (aId) {
            return this._items[aId];
        };
        // -------------------------------------------------------------------------
        IdNameMap.prototype.getByName = function (aName) {
            var id = this._itemNames[aName];
            // TODO remove
            if (typeof id !== "number") {
                console.warn("item " + aName + "  not found!");
            }
            return (typeof id === "number") ? this._items[id] : null;
        };
        // -------------------------------------------------------------------------
        IdNameMap.prototype.getLength = function () {
            return this._items.length;
        };
        return IdNameMap;
    })();
    Helper.IdNameMap = IdNameMap;
})(Helper || (Helper = {}));
//# sourceMappingURL=IdNameMap.js.map
///<reference path="Structure/SpatialTimelineKey.ts"/>
///<reference path="Structure/SpatialInfo.ts"/>
///<reference path="Structure/Animation.ts"/>
///<reference path="../../lib/phaser.d.ts"/>
var Spriter;
(function (Spriter) {
    var SpriterBone = (function () {
        // -------------------------------------------------------------------------
        function SpriterBone() {
            this.timelineKey = -1;
            this.transformed = new Spriter.SpatialInfo();
        }
        // -------------------------------------------------------------------------
        SpriterBone.prototype.setOn = function (aOn) {
            this._on = aOn;
        };
        // -------------------------------------------------------------------------
        SpriterBone.prototype.getOn = function () {
            return this._on;
        };
        // -------------------------------------------------------------------------
        SpriterBone.prototype.setKey = function (aAnimation, aTimelineId, aKeyId) {
            this.timelineKey = aKeyId;
            var keys = aAnimation.getTimelineById(aTimelineId).getKeys();
            var keyFrom = keys[aKeyId];
            // in the end loop to first key. If animation is not looping, then repeat last key
            var endIndex = (aKeyId + 1) % keys.length;
            if (endIndex === 0 && aAnimation.getLoopType() === Spriter.eAnimationLooping.NO_LOOPING) {
                endIndex = aKeyId;
            }
            var keyTo = keys[endIndex];
            this.key = keyFrom;
            this.timeFrom = keyFrom.getTime();
            this.timeTo = keyTo.getTime();
            // if loop to key 0
            if (this.timeTo < this.timeFrom) {
                this.timeTo = aAnimation.getLength();
            }
            this.from = keyFrom.getInfo();
            this.to = keyTo.getInfo();
            // create update mask
            this.updateMask = 0;
            if (Math.abs(this.from.x - this.to.x) > 0.001) {
                this.updateMask += SpriterBone.UPDATE_X;
            }
            if (Math.abs(this.from.y - this.to.y) > 0.001) {
                this.updateMask += SpriterBone.UPDATE_Y;
            }
            if (Math.abs(this.from.scaleX - this.to.scaleX) > 0.001) {
                this.updateMask += SpriterBone.UPDATE_SCALE_X;
            }
            if (Math.abs(this.from.scaleY - this.to.scaleY) > 0.001) {
                this.updateMask += SpriterBone.UPDATE_SCALE_Y;
            }
            if (Math.abs(this.from.pivotX - this.to.pivotX) > 0.001) {
                this.updateMask += SpriterBone.UPDATE_PIVOT_X;
            }
            if (Math.abs(this.from.pivotY - this.to.pivotY) > 0.001) {
                this.updateMask += SpriterBone.UPDATE_PIVOT_Y;
            }
            if (Math.abs(this.from.alpha - this.to.alpha) > 0.001) {
                this.updateMask += SpriterBone.UPDATE_ALPHA;
            }
            if (Math.abs(this.from.angle - this.to.angle) > 0.001) {
                this.updateMask += SpriterBone.UPDATE_ANGLE;
            }
            // init data
            this.transformed.x = this.from.x;
            this.transformed.y = this.from.y;
            this.transformed.scaleX = this.from.scaleX;
            this.transformed.scaleY = this.from.scaleY;
            this.transformed.pivotX = this.from.pivotX;
            this.transformed.pivotY = this.from.pivotY;
            this.transformed.angle = this.from.angle;
            this.transformed.alpha = this.from.alpha;
        };
        // -------------------------------------------------------------------------
        SpriterBone.prototype.tween = function (aTime) {
            // calculate normalized time
            //var t = Phaser.Math.clamp((aTime - this.timeFrom) / (this.timeTo - this.timeFrom), 0, 1);
            var t = (this.updateMask > 0) ? this.getTweenTime(aTime) : 0;
            this.transformed.x = (this.updateMask & SpriterBone.UPDATE_X) > 0 ?
                this.linear(this.from.x, this.to.x, t) : this.from.x;
            this.transformed.y = (this.updateMask & SpriterBone.UPDATE_Y) > 0 ?
                this.linear(this.from.y, this.to.y, t) : this.from.y;
            this.transformed.scaleX = (this.updateMask & SpriterBone.UPDATE_SCALE_X) > 0 ?
                this.linear(this.from.scaleX, this.to.scaleX, t) : this.from.scaleX;
            this.transformed.scaleY = (this.updateMask & SpriterBone.UPDATE_SCALE_Y) > 0 ?
                this.linear(this.from.scaleY, this.to.scaleY, t) : this.from.scaleY;
            this.transformed.pivotX = (this.updateMask & SpriterBone.UPDATE_PIVOT_X) > 0 ?
                this.linear(this.from.pivotX, this.to.pivotX, t) : this.from.pivotX;
            this.transformed.pivotY = (this.updateMask & SpriterBone.UPDATE_PIVOT_Y) > 0 ?
                this.linear(this.from.pivotY, this.to.pivotY, t) : this.from.pivotY;
            this.transformed.alpha = (this.updateMask & SpriterBone.UPDATE_ALPHA) > 0 ?
                this.linear(this.from.alpha, this.to.alpha, t) : this.from.alpha;
            this.transformed.angle = (this.updateMask & SpriterBone.UPDATE_ANGLE) > 0 ?
                this.angleLinear(this.from.angle, this.to.angle, this.key.getSpin(), t) : this.from.angle;
        };
        // -------------------------------------------------------------------------
        SpriterBone.prototype.update = function (aParent) {
            this.transformed.angle *= Phaser.Math.sign(aParent.scaleX) * Phaser.Math.sign(aParent.scaleY);
            this.transformed.angle += aParent.angle;
            this.transformed.scaleX *= aParent.scaleX;
            this.transformed.scaleY *= aParent.scaleY;
            this.scalePosition(aParent.scaleX, aParent.scaleY);
            this.rotatePosition(aParent.angle);
            this.translatePosition(aParent.x, aParent.y);
            this.transformed.alpha *= aParent.alpha;
        };
        // -------------------------------------------------------------------------
        SpriterBone.prototype.scalePosition = function (aParentScaleX, aParentScaleY) {
            this.transformed.x *= aParentScaleX;
            this.transformed.y *= aParentScaleY;
        };
        // -------------------------------------------------------------------------
        SpriterBone.prototype.rotatePosition = function (aParentAngle) {
            var x = this.transformed.x;
            var y = this.transformed.y;
            if (x !== 0 || y !== 0) {
                var rads = aParentAngle * (Math.PI / 180);
                var cos = Math.cos(rads);
                var sin = Math.sin(rads);
                this.transformed.x = x * cos - y * sin;
                this.transformed.y = x * sin + y * cos;
            }
        };
        // -------------------------------------------------------------------------
        SpriterBone.prototype.translatePosition = function (aParentX, aParentY) {
            this.transformed.x += aParentX;
            this.transformed.y += aParentY;
        };
        // -------------------------------------------------------------------------
        SpriterBone.prototype.getTweenTime = function (aTime) {
            if (this.key.getCurveType() === Spriter.eCurveType.INSTANT) {
                return 0;
            }
            var t = Phaser.Math.clamp((aTime - this.timeFrom) / (this.timeTo - this.timeFrom), 0, 1);
            switch (this.key.getCurveType()) {
                case Spriter.eCurveType.LINEAR:
                    return t;
                case Spriter.eCurveType.QUADRATIC:
                    return this.quadratic(0, this.key.getC1(), 1, t);
                case Spriter.eCurveType.CUBIC:
                    return this.cubic(0, this.key.getC1(), this.key.getC2(), 1, t);
            }
            return 0;
        };
        // -------------------------------------------------------------------------
        SpriterBone.prototype.linear = function (aA, aB, aT) {
            return ((aB - aA) * aT) + aA;
        };
        // -------------------------------------------------------------------------
        SpriterBone.prototype.quadratic = function (aA, aB, aC, aT) {
            return this.linear(this.linear(aA, aB, aT), this.linear(aB, aC, aT), aT);
        };
        // -------------------------------------------------------------------------
        SpriterBone.prototype.cubic = function (aA, aB, aC, aD, aT) {
            return this.linear(this.quadratic(aA, aB, aC, aT), this.quadratic(aB, aC, aD, aT), aT);
        };
        // -------------------------------------------------------------------------
        SpriterBone.prototype.angleLinear = function (aAngleA, aAngleB, aSpin, aT) {
            // no spin
            if (aSpin === 0) {
                return aAngleA;
            }
            // spin left
            if (aSpin > 0) {
                if (aAngleB > aAngleA) {
                    aAngleB -= 360;
                }
            }
            else {
                if (aAngleB < aAngleA) {
                    aAngleB += 360;
                }
            }
            return this.linear(aAngleA, aAngleB, aT);
        };
        SpriterBone.UPDATE_X = 1;
        SpriterBone.UPDATE_Y = 2;
        SpriterBone.UPDATE_SCALE_X = 4;
        SpriterBone.UPDATE_SCALE_Y = 8;
        SpriterBone.UPDATE_PIVOT_X = 16;
        SpriterBone.UPDATE_PIVOT_Y = 32;
        SpriterBone.UPDATE_ANGLE = 64;
        SpriterBone.UPDATE_ALPHA = 128;
        return SpriterBone;
    })();
    Spriter.SpriterBone = SpriterBone;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=SpriterBone.js.map
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
///<reference path="../../lib/phaser.d.ts"/>
///<reference path="Spriter.ts"/>
///<reference path="Structure/Animation.ts"/>
///<reference path="SpriterBone.ts"/>
///<reference path="Structure/SpatialInfo.ts"/>
var Spriter;
(function (Spriter) {
    var SpriterGroup = (function (_super) {
        __extends(SpriterGroup, _super);
        // -------------------------------------------------------------------------
        function SpriterGroup(aGame, aSpriter, aTextureKey, aEntityName, aAnimation, aAnimationSpeedPercent) {
            _super.call(this, aGame, null);
            this._bones = [];
            this._objects = [];
            this._pause = false;
            this._listener = null;
            this._spriter = aSpriter;
            this._entityName = aEntityName;
            this._textureKey = aTextureKey;
            this._root = new Spriter.SpatialInfo();
            // set animation speed
            if (aAnimationSpeedPercent === undefined) {
                aAnimationSpeedPercent = 100;
            }
            this.setAnimationSpeedPercent(aAnimationSpeedPercent);
            // set animation
            if (aAnimation === undefined || aAnimation === null) {
                // set first animation
                this.setAnimationById(0);
            }
            else if (typeof aAnimation === "number") {
                this.setAnimationById(aAnimation);
            }
            else {
                this.setAnimationByName(aAnimation);
            }
        }
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.setListener = function (aListener) {
            this._listener = aListener;
        };
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.getAnimationCount = function () {
            return this._spriter.getEntityByName(this._entityName).getAnimationsCount();
        };
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.getCurrentAnimationName = function () {
            return this._currentAnimationName;
        };
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.setAnimationSpeedPercent = function (aAnimationSpeedPercent) {
            if (aAnimationSpeedPercent === void 0) { aAnimationSpeedPercent = 100; }
            this._animationSpeed = aAnimationSpeedPercent / 100;
        };
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.setAnimationById = function (aAnimationId) {
            var animation = this._spriter.getEntityByName(this._entityName).getAnimationById(aAnimationId);
            if (animation === undefined || animation === null) {
                console.warn("Animation " + aAnimationId + " for entity " + this._entityName + " does not exist!");
                return;
            }
            this.setAnimation(animation);
        };
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.setAnimationByName = function (aAnimationName) {
            var animation = this._spriter.getEntityByName(this._entityName).getAnimationByName(aAnimationName);
            if (animation === undefined || animation === null) {
                console.warn("Animation " + aAnimationName + " for entity " + this._entityName + " does not exist!");
                return;
            }
            this.setAnimation(animation);
        };
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.setAnimation = function (aAnimation) {
            this._currentAnimationName = aAnimation.getName();
            this._animation = aAnimation;
            this._finished = false;
            // reset time to beginning of animation and find first from and to keys
            this.clearTime();
            // create bones and sprites - based on data in mainLine key 0
            this.loadKeys(0, true);
            // first update - to set correct positions
            this.updateCharacter();
        };
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.clearTime = function () {
            this._time = 0;
            this._keyIndex = -1;
        };
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.getNextMainLineKeyTime = function (aTime) {
            var keys = this._animation.getMainLineKeys();
            var newIndex = (this._keyIndex + 1) % keys.length;
            this._nextTime = newIndex !== 0 ? keys[newIndex].getTime() : this._animation.getLength();
            // game is lagging or keys are to close to each other - notify in console
            //            if (newIndex !== 0 && this._nextTime < aTime) {
            //                console.log("Game is lagging or keys are too close to each other...");
            //            }
        };
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.setBones = function (aBones, aForce) {
            if (aForce === void 0) { aForce = false; }
            // switch off all existing bones
            for (var i = 0; i < this._bones.length; i++) {
                if (this._bones[i] !== undefined) {
                    this._bones[i].setOn(false);
                }
            }
            // go through all bones and add new ones if necessary and activate used ones
            for (var i = 0; i < aBones.length; i++) {
                var ref = aBones[i];
                // if bone does not exist add it and make active, else make it active only
                if (this._bones[ref.id] === undefined) {
                    this._bones[ref.id] = new Spriter.SpriterBone();
                }
                var bone = this._bones[ref.id];
                bone.setOn(true);
                bone.parent = ref.parent;
                if (bone.timelineKey != ref.key || aForce) {
                    bone.setKey(this._animation, ref.timeline, ref.key);
                }
            }
        };
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.setObjects = function (aObjects, aForce) {
            if (aForce === void 0) { aForce = false; }
            // switch off (kill) all existing sprites
            for (var i = 0; i < this._objects.length; i++) {
                if (this._objects[i] !== undefined) {
                    this._objects[i].setOn(false);
                }
            }
            // go through all objects/sprites and add new ones if necessary and activate used ones
            var zChange = false;
            for (var i = 0; i < aObjects.length; i++) {
                var ref = aObjects[i];
                var object = null;
                var sprite = null;
                // if sprite does not exist add it and make active, else make it active only
                if (this._objects[ref.id] === undefined) {
                    sprite = new Phaser.Sprite(this.game, 0, 0, this._textureKey);
                    object = new Spriter.SpriterObject(this._spriter, sprite);
                    this._objects[ref.id] = object;
                    this.add(sprite);
                }
                else {
                    object = this._objects[ref.id];
                    sprite = object.getSprite();
                }
                object.setOn(true);
                object.parent = ref.parent;
                if (object.getSprite().z !== ref.z) {
                    object.getSprite().z = ref.z;
                    zChange = true;
                }
                if (object.timelineKey != ref.key || aForce) {
                    object.setKey(this._animation, ref.timeline, ref.key);
                }
            }
            // need to sort sprites?
            if (zChange) {
                this.sort();
            }
        };
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.loadKeys = function (aMainLineKeyIndex, aForce) {
            if (aForce === void 0) { aForce = false; }
            // create or update bones and sprites
            this.setBones(this._animation.getMainLineKeys()[aMainLineKeyIndex].getBoneRefs(), aForce);
            this.setObjects(this._animation.getMainLineKeys()[aMainLineKeyIndex].getObjectRefs(), aForce);
        };
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.updateAnimation = function () {
            if (this._pause || this._finished) {
                return;
            }
            if (this._keyIndex === -1 || this._time > this._nextTime) {
                this._keyIndex = (this._keyIndex + 1) % this._animation.getMainLineKeys().length;
                // start anim from beginning again
                if (this._time > this._animation.getLength()) {
                    if (this._animation.getLoopType() === Spriter.eAnimationLooping.NO_LOOPING) {
                        // prevent skipping all keys in the very end of animation - loop through all of them and adjust sprites
                        while (this._keyIndex !== 0) {
                            this.getNextMainLineKeyTime(this._time);
                            this.loadKeys(this._keyIndex);
                            this.updateCharacter();
                            this._keyIndex = (this._keyIndex + 1) % this._animation.getMainLineKeys().length;
                        }
                        this._finished = true;
                        this.onFinished();
                        return;
                    }
                    this.onLoop();
                    this._time = 0;
                    this._keyIndex = 0;
                }
                this.getNextMainLineKeyTime(this._time);
                this.loadKeys(this._keyIndex);
            }
            this.updateCharacter();
            this._time += (this.game.time.physicsElapsedMS * this._animationSpeed);
        };
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.updateCharacter = function () {
            for (var i = 0; i < this._bones.length; i++) {
                var bone = this._bones[i];
                if (bone.getOn()) {
                    var parentSpatial = (bone.parent === -1) ? this._root : this._bones[bone.parent].transformed;
                    bone.tween(this._time);
                    bone.update(parentSpatial);
                }
            }
            for (var i = 0; i < this._objects.length; i++) {
                var object = this._objects[i];
                if (object.getOn()) {
                    var parentSpatial = (object.parent === -1) ? this._root : this._bones[object.parent].transformed;
                    object.tween(this._time);
                    object.update(parentSpatial);
                }
            }
        };
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.onLoop = function () {
            // do nothing by default;
        };
        // -------------------------------------------------------------------------
        SpriterGroup.prototype.onFinished = function () {
            if (this._listener !== null) {
                this._listener.onAnimationFinished(this);
            }
        };
        return SpriterGroup;
    })(Phaser.Group);
    Spriter.SpriterGroup = SpriterGroup;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=SpriterGroup.js.map
///<reference path="SpriterGroup.ts"/>
//# sourceMappingURL=SpriterGroupListener.js.map
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
///<reference path="Structure/Animation.ts"/>
///<reference path="Spriter.ts"/>
///<reference path="Structure/ObjectTimelineKey.ts"/>
var Spriter;
(function (Spriter) {
    var SpriterObject = (function (_super) {
        __extends(SpriterObject, _super);
        // -------------------------------------------------------------------------
        function SpriterObject(aSpriter, aSprite) {
            _super.call(this);
            this._spriter = aSpriter;
            this._sprite = aSprite;
        }
        // -------------------------------------------------------------------------
        SpriterObject.prototype.getSprite = function () {
            return this._sprite;
        };
        // -------------------------------------------------------------------------
        SpriterObject.prototype.setOn = function (aOn) {
            _super.prototype.setOn.call(this, aOn);
            this._sprite.exists = aOn;
            this._sprite.visible = aOn;
        };
        // -------------------------------------------------------------------------
        SpriterObject.prototype.setKey = function (aAnimation, aTimelineId, aKeyId) {
            _super.prototype.setKey.call(this, aAnimation, aTimelineId, aKeyId);
            // set sprite
            var spriteKey = this.key;
            var file = this._spriter.getFolderById(spriteKey.getFolder()).getFileById(spriteKey.getFile());
            this._sprite.frameName = file.getName();
        };
        // -------------------------------------------------------------------------
        SpriterObject.prototype.update = function (aParent) {
            _super.prototype.update.call(this, aParent);
            this.updateSprite();
        };
        // -------------------------------------------------------------------------
        SpriterObject.prototype.updateSprite = function () {
            var t = this.transformed;
            var s = this.getSprite();
            s.position.setTo(t.x, t.y);
            s.scale.setTo(t.scaleX, t.scaleY);
            s.anchor.setTo(t.pivotX, t.pivotY);
            s.alpha = t.alpha;
            s.angle = t.angle;
        };
        return SpriterObject;
    })(Spriter.SpriterBone);
    Spriter.SpriterObject = SpriterObject;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=SpriterObject.js.map
///<reference path="../Structure/Folder.ts"/>
///<reference path="../Structure/Entity.ts"/>
///<reference path="../Spriter.ts"/>
//# sourceMappingURL=ISpriterNodeList.js.map
///<reference path="../Spriter.ts"/>
///<reference path="LoaderSpriterFile.ts"/>
///<reference path="ISpriterNodeList.ts"/>
var Spriter;
(function (Spriter) {
    var Loader = (function () {
        function Loader() {
        }
        // -------------------------------------------------------------------------
        Loader.prototype.load = function (aFile) {
            this._spriter = new Spriter.Spriter();
            // folders and files
            var folders = aFile.getNodes("folder");
            this.loadFolders(this._spriter, folders);
            folders.processed();
            // entity
            var entities = aFile.getNodes("entity");
            this.loadEntities(this._spriter, entities);
            entities.processed();
            return this._spriter;
        };
        // -------------------------------------------------------------------------
        Loader.prototype.loadFolders = function (aSpriter, aFolders) {
            // through all folders
            for (var i = 0; i < aFolders.length(); i++) {
                var folder = aFolders.getFolder(i);
                // images in folder
                var files = aFolders.getChildNodes(i, "file");
                this.loadFiles(folder, files);
                files.processed();
                // add folder to spriter object
                aSpriter.addFolder(folder);
            }
        };
        // -------------------------------------------------------------------------
        Loader.prototype.loadFiles = function (aFolder, aFiles) {
            for (var f = 0; f < aFiles.length(); f++) {
                var file = aFiles.getFile(f);
                aFolder.addFile(file);
            }
        };
        // -------------------------------------------------------------------------
        Loader.prototype.loadEntities = function (aSpriter, aEntities) {
            for (var i = 0; i < aEntities.length(); i++) {
                var entity = aEntities.getEntity(i);
                var bones = aEntities.getChildNodes(i, "obj_info");
                this.loadBones(entity, bones);
                bones.processed();
                var animations = aEntities.getChildNodes(i, "animation");
                this.loadAnimations(entity, animations);
                animations.processed();
                aSpriter.addEntity(entity);
            }
        };
        // -------------------------------------------------------------------------
        Loader.prototype.loadBones = function (aEntity, aBones) {
            for (var i = 0; i < aBones.length(); i++) {
                var bone = aBones.getObjectInfo(i);
                aEntity.addObjectInfo(bone);
            }
        };
        // -------------------------------------------------------------------------
        Loader.prototype.loadAnimations = function (aEntity, aAnimations) {
            for (var i = 0; i < aAnimations.length(); i++) {
                var animation = aAnimations.getAnimation(i);
                // main line keys
                var mainline = aAnimations.getChildNodes(i, "mainline");
                var mainlineKeys = mainline.getChildNodes(0, "key");
                this.loadMainlineKeys(animation, mainlineKeys);
                mainlineKeys.processed();
                mainline.processed();
                // timelines
                var timelines = aAnimations.getChildNodes(i, "timeline");
                this.loadTimelines(animation, timelines);
                timelines.processed();
                aEntity.addAnimation(animation);
            }
        };
        // -------------------------------------------------------------------------
        Loader.prototype.loadMainlineKeys = function (aAnimation, aMainLineKeys) {
            for (var i = 0; i < aMainLineKeys.length(); i++) {
                var mainLineKey = aMainLineKeys.getMainLineKey(i);
                // load bone refs
                var boneRefs = aMainLineKeys.getChildNodes(i, "bone_ref");
                for (var b = 0; b < boneRefs.length(); b++) {
                    mainLineKey.addBoneRef(boneRefs.getRef(b));
                }
                boneRefs.processed();
                // load sprite refs (object refs)
                var spriteRefs = aMainLineKeys.getChildNodes(i, "object_ref");
                for (var s = 0; s < spriteRefs.length(); s++) {
                    mainLineKey.addObjectRef(spriteRefs.getRef(s));
                }
                spriteRefs.processed();
                aAnimation.addMainLineKey(mainLineKey);
            }
        };
        // -------------------------------------------------------------------------
        Loader.prototype.loadTimelines = function (aAnimation, aTimelines) {
            for (var i = 0; i < aTimelines.length(); i++) {
                var timeline = aTimelines.getTimeline(i);
                var keys = aTimelines.getChildNodes(i, "key");
                this.loadTimelineKeys(timeline, keys);
                keys.processed();
                aAnimation.addTimeline(timeline);
            }
        };
        // -------------------------------------------------------------------------
        Loader.prototype.loadTimelineKeys = function (aTimeline, aKeys) {
            for (var i = 0; i < aKeys.length(); i++) {
                var key = aKeys.getTimelineKey(i, this._spriter);
                aTimeline.addKey(key);
            }
        };
        return Loader;
    })();
    Spriter.Loader = Loader;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=Loader.js.map
///<reference path="ISpriterNodeList.ts"/>
var Spriter;
(function (Spriter) {
    var LoaderSpriterFile = (function () {
        function LoaderSpriterFile() {
        }
        // -------------------------------------------------------------------------
        LoaderSpriterFile.prototype.getNodes = function (aNodeName) {
            return null;
        };
        // -------------------------------------------------------------------------
        LoaderSpriterFile.prototype.processed = function () {
            this.popMinDefsStack();
        };
        // -------------------------------------------------------------------------
        LoaderSpriterFile.prototype.setMinimized = function (aMinimized, aMinDefs) {
            if (aMinDefs === void 0) { aMinDefs = null; }
            this._minimized = aMinimized;
            this._minDefs = aMinDefs;
            if (aMinimized) {
                this._minDefsStack = [];
                if (aMinDefs === null) {
                    console.error("Spriter file is minimized - you must provide object with name definitions");
                    return;
                }
            }
        };
        // -------------------------------------------------------------------------
        LoaderSpriterFile.prototype.getFileNameWithoutExtension = function (aPath) {
            var name = (aPath.split('\\').pop().split('/').pop().split('.'))[0];
            return name;
        };
        // -------------------------------------------------------------------------
        LoaderSpriterFile.prototype.translateElementName = function (aElementName) {
            if (this._minimized) {
                if (this._minDefs["name"] !== aElementName) {
                    console.warn("current definition is " + this._minDefs["name"]);
                    return aElementName;
                }
                if (this._minDefs["minName"] !== null) {
                    aElementName = this._minDefs["minName"];
                }
            }
            return aElementName;
        };
        // -------------------------------------------------------------------------
        LoaderSpriterFile.prototype.translateChildElementName = function (aElementName) {
            if (this._minimized && this._minDefs !== null) {
                var elements = this._minDefs["childElements"];
                if (elements !== null) {
                    aElementName = elements[aElementName] === null ? aElementName : elements[aElementName]["minName"];
                }
            }
            return aElementName;
        };
        // -------------------------------------------------------------------------
        LoaderSpriterFile.prototype.translateAttributeName = function (aAttributeName) {
            if (this._minimized && this._minDefs !== null) {
                var attributes = this._minDefs["attributes"];
                if (attributes !== null) {
                    aAttributeName = attributes[aAttributeName] === null ? aAttributeName : attributes[aAttributeName];
                }
            }
            return aAttributeName;
        };
        // -------------------------------------------------------------------------
        LoaderSpriterFile.prototype.setMinDefsToElementName = function (aTagName) {
            if (this._minimized) {
                // save current level of min defs
                this._minDefsStack.push(this._minDefs);
                // get child definition and set it as current
                var minDef = this._minDefs["childElements"][aTagName];
                this._minDefs = minDef;
            }
        };
        // -------------------------------------------------------------------------
        LoaderSpriterFile.prototype.popMinDefsStack = function () {
            if (this._minimized) {
                this._minDefs = this._minDefsStack.pop();
            }
        };
        return LoaderSpriterFile;
    })();
    Spriter.LoaderSpriterFile = LoaderSpriterFile;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=LoaderSpriterFile.js.map
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
///<reference path="NodeListBin.ts"/>
///<reference path="ISpriterNodeList.ts"/>
///<reference path="LoaderSpriterFile.ts"/>
///<reference path="../Structure/BoneTimelineKey.ts"/>
var Spriter;
(function (Spriter) {
    var SpriterBin = (function (_super) {
        __extends(SpriterBin, _super);
        // -------------------------------------------------------------------------
        function SpriterBin(aBinData) {
            _super.call(this);
            this._elements = {
                "spriter_data": 1,
                "folder": 2,
                "file": 3,
                "entity": 4,
                "obj_info": 5,
                "frames": 6,
                "i": 7,
                "animation": 8,
                "mainline": 9,
                "key": 10,
                "bone_ref": 11,
                "object_ref": 12,
                "timeline": 13,
                "bone": 14,
                "object": 15
            };
            this._smallOffset = false;
            this._bin = new DataView(aBinData);
            this._smallOffset = this._bin.getUint8(0) === 1;
        }
        // -------------------------------------------------------------------------
        SpriterBin.prototype.readUint8 = function () {
            return this._bin.getUint8(this._tmpPosition++);
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.readInt8 = function () {
            return this._bin.getInt8(this._tmpPosition++);
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.readUint16 = function () {
            var value = this._bin.getUint16(this._tmpPosition, true);
            this._tmpPosition += 2;
            return value;
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.readInt16 = function () {
            var value = this._bin.getInt16(this._tmpPosition, true);
            this._tmpPosition += 2;
            return value;
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.readUint32 = function () {
            var value = this._bin.getUint32(this._tmpPosition, true);
            this._tmpPosition += 4;
            return value;
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.readInt32 = function () {
            var value = this._bin.getInt32(this._tmpPosition, true);
            this._tmpPosition += 4;
            return value;
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.readFixed16_16 = function () {
            var value = this._bin.getInt32(this._tmpPosition, true);
            this._tmpPosition += 4;
            return value / 65536;
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.readFixed1_7 = function () {
            var value = this._bin.getInt32(this._tmpPosition++) & 0xFF;
            return value / 128;
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.readString = function () {
            var chars = [];
            for (var i = this._bin.getUint8(this._tmpPosition++) - 1; i >= 0; i--) {
                chars.push(this._bin.getUint8(this._tmpPosition++));
            }
            return String.fromCharCode.apply(null, chars);
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.getNodes = function (aNodeName) {
            return new Spriter.NodeListBin(this, this.getSubNodesOfElementType(1, this._elements[aNodeName]));
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.getNodesForElement = function (aElementPosition, aNodeName) {
            return new Spriter.NodeListBin(this, this.getSubNodesOfElementType(aElementPosition, this._elements[aNodeName]));
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.getSubNodesOfElementType = function (aPosition, aElementType) {
            var result = [];
            var subelementsCount = this._bin.getUint8(aPosition + 1);
            aPosition += 2;
            for (var i = 0; i < subelementsCount; i++) {
                var subelementOffset = this._smallOffset ? this._bin.getUint16(aPosition + i * 2, true) : this._bin.getUint32(aPosition + i * 4, true);
                var subelementType = this._bin.getUint8(aPosition + subelementOffset);
                if (subelementType === aElementType) {
                    result.push(aPosition + subelementOffset);
                }
            }
            return result;
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.getAttribsPosition = function (aPosition) {
            var subelementsCount = this._bin.getUint8(aPosition + 1);
            return aPosition + 2 + subelementsCount * (this._smallOffset ? 2 : 4);
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.getFolder = function (aPosition) {
            this._tmpPosition = this.getAttribsPosition(aPosition);
            var id = 0;
            var name = "";
            for (var i = this._bin.getUint8(this._tmpPosition++) - 1; i >= 0; i--) {
                switch (this._bin.getUint8(this._tmpPosition++)) {
                    case SpriterBin.ATTR_FOLDER_ID:
                        id = this.readUint8();
                        break;
                    case SpriterBin.ATTR_FOLDER_NAME:
                        name = this.readString();
                        break;
                }
            }
            return new Spriter.Folder(id, name);
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.getFile = function (aPosition) {
            this._tmpPosition = this.getAttribsPosition(aPosition);
            var id = 0;
            var name = "";
            var pivotX = 0;
            var pivotY = 0;
            for (var i = this._bin.getUint8(this._tmpPosition++) - 1; i >= 0; i--) {
                switch (this._bin.getUint8(this._tmpPosition++)) {
                    case SpriterBin.ATTR_FILE_ID:
                        id = this.readUint8();
                        break;
                    case SpriterBin.ATTR_FILE_NAME:
                        name = this.readString();
                        break;
                    case SpriterBin.ATTR_FILE_PIVOT_X:
                        pivotX = this.readFixed16_16();
                        break;
                    case SpriterBin.ATTR_FILE_PIVOT_Y:
                        pivotY = this.readFixed16_16();
                        break;
                    case SpriterBin.ATTR_FILE_WIDTH:
                    case SpriterBin.ATTR_FILE_HEIGHT:
                        // ignore - just skip
                        this._tmpPosition += 2;
                        break;
                }
            }
            return new Spriter.SpriterFile(id, this.getFileNameWithoutExtension(name), pivotX, 1 - pivotY);
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.getEntity = function (aPosition) {
            this._tmpPosition = this.getAttribsPosition(aPosition);
            var id = 0;
            var name = "";
            for (var i = this._bin.getUint8(this._tmpPosition++) - 1; i >= 0; i--) {
                switch (this._bin.getUint8(this._tmpPosition++)) {
                    case SpriterBin.ATTR_ENTITY_ID:
                        id = this.readUint8();
                        break;
                    case SpriterBin.ATTR_ENTITY_NAME:
                        name = this.readString();
                        break;
                }
            }
            return new Spriter.Entity(id, name);
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.getObjectInfo = function (aPosition, aIndex) {
            this._tmpPosition = this.getAttribsPosition(aPosition);
            var name = "";
            var type = Spriter.eObjectType.SPRITE;
            var width = 0;
            var height = 0;
            for (var i = this._bin.getUint8(this._tmpPosition++) - 1; i >= 0; i--) {
                switch (this._bin.getUint8(this._tmpPosition++)) {
                    case SpriterBin.ATTR_OBJ_INFO_NAME:
                        name = this.readString();
                        break;
                    case SpriterBin.ATTR_OBJ_INFO_TYPE:
                        if (this.readUint8() === 1) {
                            type = Spriter.eObjectType.BONE;
                        }
                        break;
                    case SpriterBin.ATTR_OBJ_INFO_WIDTH:
                        width = this.readFixed16_16();
                        break;
                    case SpriterBin.ATTR_OBJ_INFO_HEIGHT:
                        height = this.readFixed16_16();
                        break;
                }
            }
            return new Spriter.ObjectInfo(aIndex, name, type, width, height);
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.getAnimation = function (aPosition) {
            this._tmpPosition = this.getAttribsPosition(aPosition);
            var id = 0;
            var name = "";
            var length = 0;
            var interval = 0;
            var looping = Spriter.eAnimationLooping.LOOPING;
            for (var i = this._bin.getUint8(this._tmpPosition++) - 1; i >= 0; i--) {
                switch (this._bin.getUint8(this._tmpPosition++)) {
                    case SpriterBin.ATTR_ANIMATION_ID:
                        id = this.readUint8();
                        break;
                    case SpriterBin.ATTR_ANIMATION_NAME:
                        name = this.readString();
                        break;
                    case SpriterBin.ATTR_ANIMATION_LENGTH:
                        length = this.readUint32();
                        break;
                    case SpriterBin.ATTR_ANIMATION_INTERVAL:
                        // ignore - skip
                        this._tmpPosition += 2;
                        break;
                    case SpriterBin.ATTR_ANIMATION_LOOPING:
                        looping = (this.readUint8() === 1) ? Spriter.eAnimationLooping.LOOPING : Spriter.eAnimationLooping.NO_LOOPING;
                        break;
                }
            }
            return new Spriter.Animation(id, name, length, looping);
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.getMainLineKey = function (aPosition) {
            this._tmpPosition = this.getAttribsPosition(aPosition);
            var time = 0;
            for (var i = this._bin.getUint8(this._tmpPosition++) - 1; i >= 0; i--) {
                switch (this._bin.getUint8(this._tmpPosition++)) {
                    case SpriterBin.ATTR_MAINLINE_KEY_ID:
                        // skip
                        this._tmpPosition++;
                        break;
                    case SpriterBin.ATTR_MAINLINE_KEY_TIME:
                        time = this.readUint32();
                        break;
                }
            }
            return new Spriter.MainLineKey(time);
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.getRef = function (aPosition) {
            this._tmpPosition = this.getAttribsPosition(aPosition);
            var id = 0;
            var parent = -1;
            var timeline = 0;
            var key = 0;
            var z_index = 0;
            for (var i = this._bin.getUint8(this._tmpPosition++) - 1; i >= 0; i--) {
                switch (this._bin.getUint8(this._tmpPosition++)) {
                    case SpriterBin.ATTR_BONE_REF_ID:
                    case SpriterBin.ATTR_OBJ_REF_ID:
                        id = this.readUint8();
                        break;
                    case SpriterBin.ATTR_BONE_REF_PARENT:
                    case SpriterBin.ATTR_OBJ_REF_PARENT:
                        parent = this.readUint8();
                        break;
                    case SpriterBin.ATTR_BONE_REF_TIMELINE:
                    case SpriterBin.ATTR_OBJ_REF_TIMELINE:
                        timeline = this.readUint8();
                        break;
                    case SpriterBin.ATTR_BONE_REF_KEY:
                    case SpriterBin.ATTR_OBJ_REF_KEY:
                        key = this.readUint8();
                        break;
                    case SpriterBin.ATTR_OBJ_REF_Z:
                        z_index = this.readUint8();
                        break;
                    case SpriterBin.ATTR_OBJ_REF_NAME:
                        // waste
                        this.readString();
                        break;
                    case SpriterBin.ATTR_OBJ_REF_FOLDER:
                    case SpriterBin.ATTR_OBJ_REF_FILE:
                        ++this._tmpPosition;
                        break;
                    case SpriterBin.ATTR_OBJ_REF_ABS_X:
                    case SpriterBin.ATTR_OBJ_REF_ABS_Y:
                    case SpriterBin.ATTR_OBJ_REF_ABS_PIVOT_X:
                    case SpriterBin.ATTR_OBJ_REF_ABS_PIVOT_Y:
                    case SpriterBin.ATTR_OBJ_REF_ABS_SCALE_X:
                    case SpriterBin.ATTR_OBJ_REF_ABS_SCALE_Y:
                    case SpriterBin.ATTR_OBJ_REF_ANGLE:
                        // skip
                        this._tmpPosition += 4;
                        break;
                    case SpriterBin.ATTR_OBJ_REF_ALPHA:
                        // skip
                        ++this._tmpPosition;
                        break;
                }
            }
            return new Spriter.Ref(id, parent, timeline, key, z_index);
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.getTimeline = function (aPosition) {
            this._tmpPosition = this.getAttribsPosition(aPosition);
            var id = 0;
            var name = "";
            var obj = 0;
            var type = Spriter.eObjectType.SPRITE;
            for (var i = this._bin.getUint8(this._tmpPosition++) - 1; i >= 0; i--) {
                switch (this._bin.getUint8(this._tmpPosition++)) {
                    case SpriterBin.ATTR_TIMELINE_ID:
                        id = this.readUint8();
                        break;
                    case SpriterBin.ATTR_TIMELINE_NAME:
                        name = this.readString();
                        break;
                    case SpriterBin.ATTR_TIMELINE_OBJ:
                        obj = this.readUint8();
                        break;
                    case SpriterBin.ATTR_TIMELINE_OBJ_TYPE:
                        if (this.readUint8() === 1) {
                            type = Spriter.eObjectType.BONE;
                        }
                        break;
                }
            }
            return new Spriter.Timeline(id, name, type, obj);
        };
        // -------------------------------------------------------------------------
        SpriterBin.prototype.getTimelineKey = function (aPosition, aIndex, aSpriter) {
            this._tmpPosition = this.getAttribsPosition(aPosition);
            var time = 0;
            var spin = 1;
            // curve and params
            var curve = Spriter.eCurveType.LINEAR;
            var c1 = 0;
            var c2 = 0;
            var c3 = 0;
            var c4 = 0;
            for (var i = this._bin.getUint8(this._tmpPosition++) - 1; i >= 0; i--) {
                switch (this._bin.getUint8(this._tmpPosition++)) {
                    case SpriterBin.ATTR_TIMELINE_KEY_ID:
                        // skip
                        ++this._tmpPosition;
                        break;
                    case SpriterBin.ATTR_TIMELINE_KEY_TIME:
                        time = this.readUint32();
                        break;
                    case SpriterBin.ATTR_TIMELINE_KEY_SPIN:
                        spin = this.readInt8();
                        break;
                    case SpriterBin.ATTR_TIMELINE_KEY_CURVE:
                        curve = this.readUint8();
                        break;
                    case SpriterBin.ATTR_TIMELINE_KEY_C1:
                        c1 = this.readFixed1_7();
                        break;
                    case SpriterBin.ATTR_TIMELINE_KEY_C2:
                        c2 = this.readFixed1_7();
                        break;
                }
            }
            // get child element
            aPosition += 2;
            var offset = aPosition + (this._smallOffset ? this._bin.getUint16(aPosition, true) : this._bin.getUint32(aPosition, true));
            var elementType = this._bin.getUint8(offset);
            var key = null;
            var keyDataElm = null;
            var sprite = false;
            if (elementType === 14 /* bone */) {
                key = new Spriter.BoneTimelineKey(aIndex, time, spin);
            }
            else if (elementType === 15 /* object */) {
                key = new Spriter.ObjectTimelineKey(aIndex, time, spin);
                sprite = true;
            }
            // other curve than linear?
            if (curve !== Spriter.eCurveType.LINEAR) {
                key.setCurve(curve, c1, c2, c3, c4);
            }
            this._tmpPosition = this.getAttribsPosition(offset);
            // spatial info
            var info = key.getInfo();
            info.x = 0; //this.parseFloat(keyDataElm, "x");
            info.y = 0; //-this.parseFloat(keyDataElm, "y");
            info.scaleX = 1; // this.parseFloat(keyDataElm, "scale_x", 1);
            info.scaleY = 1; //this.parseFloat(keyDataElm, "scale_y", 1);
            info.angle = 0; //360 - this.parseFloat(keyDataElm, "angle");
            info.alpha = 1; //this.parseFloat(keyDataElm, "a", 1);
            var pivotX = 0;
            var hasPivotX = false;
            var pivotY = 0;
            var hasPivotY = false;
            var folder = 0;
            var file = 0;
            for (var i = this._bin.getUint8(this._tmpPosition++) - 1; i >= 0; i--) {
                switch (this._bin.getUint8(this._tmpPosition++)) {
                    case SpriterBin.ATTR_BONE_X:
                    case SpriterBin.ATTR_OBJ_X:
                        info.x = this.readFixed16_16();
                        break;
                    case SpriterBin.ATTR_BONE_Y:
                    case SpriterBin.ATTR_OBJ_Y:
                        info.y = -this.readFixed16_16();
                        break;
                    case SpriterBin.ATTR_BONE_ANGLE:
                    case SpriterBin.ATTR_OBJ_ANGLE:
                        info.angle = 360 - this.readFixed16_16();
                        break;
                    case SpriterBin.ATTR_BONE_SCALE_X:
                    case SpriterBin.ATTR_OBJ_SCALE_X:
                        info.scaleX = this.readFixed16_16();
                        break;
                    case SpriterBin.ATTR_BONE_SCALE_Y:
                    case SpriterBin.ATTR_OBJ_SCALE_Y:
                        info.scaleY = this.readFixed16_16();
                        break;
                    case SpriterBin.ATTR_OBJ_FOLDER:
                        folder = this.readUint8();
                        break;
                    case SpriterBin.ATTR_OBJ_FILE:
                        file = this.readUint8();
                        break;
                    case SpriterBin.ATTR_OBJ_PIVOT_X:
                        pivotX = this.readFixed16_16();
                        hasPivotX = true;
                        break;
                    case SpriterBin.ATTR_OBJ_PIVOT_Y:
                        pivotY = this.readFixed16_16();
                        hasPivotY = true;
                        break;
                    case SpriterBin.ATTR_OBJ_ALPHA:
                        info.alpha = this.readFixed1_7();
                        break;
                }
            }
            if (sprite) {
                key.setFolderAndFile(folder, file);
                // set pivot in spatial info different from default (based on pivot in file)
                var fileObj = aSpriter.getFolderById(folder).getFileById(file);
                info.pivotX = hasPivotX ? pivotX : fileObj.getAnchorX();
                // 1 - to flip Y, default anchor is already flipped, so it needs to be flipped back to avoid double flipping
                info.pivotY = 1 - (hasPivotY ? pivotY : 1 - fileObj.getAnchorY());
            }
            return key;
        };
        // spriter data
        SpriterBin.ATTR_VERSION = 0;
        SpriterBin.ATTR_GENERATOR = 1;
        SpriterBin.ATTR_GENERATOR_VERSION = 2;
        // folder
        SpriterBin.ATTR_FOLDER_ID = 0;
        SpriterBin.ATTR_FOLDER_NAME = 1;
        // file
        SpriterBin.ATTR_FILE_ID = 0;
        SpriterBin.ATTR_FILE_NAME = 1;
        SpriterBin.ATTR_FILE_WIDTH = 2;
        SpriterBin.ATTR_FILE_HEIGHT = 3;
        SpriterBin.ATTR_FILE_PIVOT_X = 4;
        SpriterBin.ATTR_FILE_PIVOT_Y = 5;
        // entity
        SpriterBin.ATTR_ENTITY_ID = 0;
        SpriterBin.ATTR_ENTITY_NAME = 1;
        // obj_info
        SpriterBin.ATTR_OBJ_INFO_NAME = 0;
        SpriterBin.ATTR_OBJ_INFO_TYPE = 1;
        SpriterBin.ATTR_OBJ_INFO_WIDTH = 2;
        SpriterBin.ATTR_OBJ_INFO_HEIGHT = 3;
        // frames
        SpriterBin.ATTR_FRAMES_I_FOLDER = 0;
        SpriterBin.ATTR_FRAMES_I_FILE = 1;
        // animation
        SpriterBin.ATTR_ANIMATION_ID = 0;
        SpriterBin.ATTR_ANIMATION_NAME = 1;
        SpriterBin.ATTR_ANIMATION_LENGTH = 2;
        SpriterBin.ATTR_ANIMATION_INTERVAL = 3;
        SpriterBin.ATTR_ANIMATION_LOOPING = 4;
        // key
        SpriterBin.ATTR_MAINLINE_KEY_ID = 0;
        SpriterBin.ATTR_MAINLINE_KEY_TIME = 1;
        // bone_ref
        SpriterBin.ATTR_BONE_REF_ID = 0;
        SpriterBin.ATTR_BONE_REF_PARENT = 1;
        SpriterBin.ATTR_BONE_REF_TIMELINE = 2;
        SpriterBin.ATTR_BONE_REF_KEY = 3;
        // object_ref
        SpriterBin.ATTR_OBJ_REF_ID = 4;
        SpriterBin.ATTR_OBJ_REF_PARENT = 5;
        SpriterBin.ATTR_OBJ_REF_TIMELINE = 6;
        SpriterBin.ATTR_OBJ_REF_KEY = 7;
        SpriterBin.ATTR_OBJ_REF_NAME = 8;
        SpriterBin.ATTR_OBJ_REF_Z = 9;
        SpriterBin.ATTR_OBJ_REF_FOLDER = 10;
        SpriterBin.ATTR_OBJ_REF_FILE = 11;
        SpriterBin.ATTR_OBJ_REF_ABS_X = 12;
        SpriterBin.ATTR_OBJ_REF_ABS_Y = 13;
        SpriterBin.ATTR_OBJ_REF_ABS_PIVOT_X = 14;
        SpriterBin.ATTR_OBJ_REF_ABS_PIVOT_Y = 15;
        SpriterBin.ATTR_OBJ_REF_ABS_SCALE_X = 16;
        SpriterBin.ATTR_OBJ_REF_ABS_SCALE_Y = 17;
        SpriterBin.ATTR_OBJ_REF_ANGLE = 18;
        SpriterBin.ATTR_OBJ_REF_ALPHA = 19;
        // timeline
        SpriterBin.ATTR_TIMELINE_ID = 0;
        SpriterBin.ATTR_TIMELINE_NAME = 1;
        SpriterBin.ATTR_TIMELINE_OBJ = 2;
        SpriterBin.ATTR_TIMELINE_OBJ_TYPE = 3;
        // key
        SpriterBin.ATTR_TIMELINE_KEY_ID = 0;
        SpriterBin.ATTR_TIMELINE_KEY_TIME = 1;
        SpriterBin.ATTR_TIMELINE_KEY_SPIN = 2;
        SpriterBin.ATTR_TIMELINE_KEY_CURVE = 3;
        SpriterBin.ATTR_TIMELINE_KEY_C1 = 4;
        SpriterBin.ATTR_TIMELINE_KEY_C2 = 5;
        // bone
        SpriterBin.ATTR_BONE_X = 0;
        SpriterBin.ATTR_BONE_Y = 1;
        SpriterBin.ATTR_BONE_ANGLE = 2;
        SpriterBin.ATTR_BONE_SCALE_X = 3;
        SpriterBin.ATTR_BONE_SCALE_Y = 4;
        // object
        SpriterBin.ATTR_OBJ_FOLDER = 5;
        SpriterBin.ATTR_OBJ_FILE = 6;
        SpriterBin.ATTR_OBJ_X = 7;
        SpriterBin.ATTR_OBJ_Y = 8;
        SpriterBin.ATTR_OBJ_SCALE_X = 9;
        SpriterBin.ATTR_OBJ_SCALE_Y = 10;
        SpriterBin.ATTR_OBJ_PIVOT_X = 11;
        SpriterBin.ATTR_OBJ_PIVOT_Y = 12;
        SpriterBin.ATTR_OBJ_ANGLE = 13;
        SpriterBin.ATTR_OBJ_ALPHA = 14;
        return SpriterBin;
    })(Spriter.LoaderSpriterFile);
    Spriter.SpriterBin = SpriterBin;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=SpriterBin.js.map
///<reference path="ISpriterNodeList.ts"/>
///<reference path="SpriterBin.ts"/>
var Spriter;
(function (Spriter) {
    var NodeListBin = (function () {
        // -------------------------------------------------------------------------
        function NodeListBin(aSpriterBin, aNodeList) {
            this._file = aSpriterBin;
            this._nodeList = aNodeList;
        }
        // -------------------------------------------------------------------------
        NodeListBin.prototype.length = function () {
            return this._nodeList.length;
        };
        // -------------------------------------------------------------------------
        NodeListBin.prototype.processed = function () {
            this._file.processed();
        };
        // -------------------------------------------------------------------------
        NodeListBin.prototype.getChildNodes = function (aIndex, aElementName) {
            return this._file.getNodesForElement(this._nodeList[aIndex], aElementName);
        };
        // -------------------------------------------------------------------------
        NodeListBin.prototype.getFolder = function (aIndex) {
            return this._file.getFolder(this._nodeList[aIndex]);
        };
        // -------------------------------------------------------------------------
        NodeListBin.prototype.getFile = function (aIndex) {
            return this._file.getFile(this._nodeList[aIndex]);
        };
        // -------------------------------------------------------------------------
        NodeListBin.prototype.getEntity = function (aIndex) {
            return this._file.getEntity(this._nodeList[aIndex]);
        };
        // -------------------------------------------------------------------------
        NodeListBin.prototype.getObjectInfo = function (aIndex) {
            return this._file.getObjectInfo(this._nodeList[aIndex], aIndex);
        };
        // -------------------------------------------------------------------------
        NodeListBin.prototype.getAnimation = function (aIndex) {
            return this._file.getAnimation(this._nodeList[aIndex]);
        };
        // -------------------------------------------------------------------------
        NodeListBin.prototype.getMainLineKey = function (aIndex) {
            return this._file.getMainLineKey(this._nodeList[aIndex]);
        };
        // -------------------------------------------------------------------------
        NodeListBin.prototype.getRef = function (aIndex) {
            return this._file.getRef(this._nodeList[aIndex]);
        };
        // -------------------------------------------------------------------------
        NodeListBin.prototype.getTimeline = function (aIndex) {
            return this._file.getTimeline(this._nodeList[aIndex]);
        };
        // -------------------------------------------------------------------------
        NodeListBin.prototype.getTimelineKey = function (aIndex, aSpriter) {
            return this._file.getTimelineKey(this._nodeList[aIndex], aIndex, aSpriter);
        };
        return NodeListBin;
    })();
    Spriter.NodeListBin = NodeListBin;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=NodeListBin.js.map
///<reference path="ISpriterNodeList.ts"/>
///<reference path="SpriterJSON.ts"/>
var Spriter;
(function (Spriter) {
    var NodeListJSON = (function () {
        // -------------------------------------------------------------------------
        function NodeListJSON(aSpriterJSON, aNodeList) {
            this._file = aSpriterJSON;
            this._nodeList = aNodeList;
        }
        // -------------------------------------------------------------------------
        NodeListJSON.prototype.length = function () {
            return this._nodeList.length;
        };
        // -------------------------------------------------------------------------
        NodeListJSON.prototype.processed = function () {
            this._file.processed();
        };
        // -------------------------------------------------------------------------
        NodeListJSON.prototype.getNode = function (aIndex) {
            if (Array.isArray(this._nodeList)) {
                return this._nodeList[aIndex];
            }
            else {
                return this._nodeList;
            }
        };
        // -------------------------------------------------------------------------
        NodeListJSON.prototype.getChildNodes = function (aIndex, aElementName) {
            return this._file.getNodesForElement(this.getNode(aIndex), aElementName);
        };
        // -------------------------------------------------------------------------
        NodeListJSON.prototype.getFolder = function (aIndex) {
            return this._file.getFolder(this.getNode(aIndex));
        };
        // -------------------------------------------------------------------------
        NodeListJSON.prototype.getFile = function (aIndex) {
            return this._file.getFile(this.getNode(aIndex));
        };
        // -------------------------------------------------------------------------
        NodeListJSON.prototype.getEntity = function (aIndex) {
            return this._file.getEntity(this.getNode(aIndex));
        };
        // -------------------------------------------------------------------------
        NodeListJSON.prototype.getObjectInfo = function (aIndex) {
            return this._file.getObjectInfo(this.getNode(aIndex), aIndex);
        };
        // -------------------------------------------------------------------------
        NodeListJSON.prototype.getAnimation = function (aIndex) {
            return this._file.getAnimation(this.getNode(aIndex));
        };
        // -------------------------------------------------------------------------
        NodeListJSON.prototype.getMainLineKey = function (aIndex) {
            return this._file.getMainLineKey(this.getNode(aIndex));
        };
        // -------------------------------------------------------------------------
        NodeListJSON.prototype.getRef = function (aIndex) {
            return this._file.getRef(this.getNode(aIndex));
        };
        // -------------------------------------------------------------------------
        NodeListJSON.prototype.getTimeline = function (aIndex) {
            return this._file.getTimeline(this.getNode(aIndex));
        };
        // -------------------------------------------------------------------------
        NodeListJSON.prototype.getTimelineKey = function (aIndex, aSpriter) {
            return this._file.getTimelineKey(this.getNode(aIndex), aIndex, aSpriter);
        };
        return NodeListJSON;
    })();
    Spriter.NodeListJSON = NodeListJSON;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=NodeListJSON.js.map
///<reference path="ISpriterNodeList.ts"/>
///<reference path="SpriterXml.ts"/>
var Spriter;
(function (Spriter) {
    var NodeListXml = (function () {
        // -------------------------------------------------------------------------
        function NodeListXml(aSpriterXml, aNodeList) {
            this._file = aSpriterXml;
            this._nodeList = aNodeList;
        }
        // -------------------------------------------------------------------------
        NodeListXml.prototype.length = function () {
            return this._nodeList.length;
        };
        // -------------------------------------------------------------------------
        NodeListXml.prototype.processed = function () {
            this._file.processed();
        };
        // -------------------------------------------------------------------------
        NodeListXml.prototype.getChildNodes = function (aIndex, aElementName) {
            return this._file.getNodesForElement(this._nodeList.item(aIndex), aElementName);
        };
        // -------------------------------------------------------------------------
        NodeListXml.prototype.getFolder = function (aIndex) {
            return this._file.getFolder(this._nodeList.item(aIndex));
        };
        // -------------------------------------------------------------------------
        NodeListXml.prototype.getFile = function (aIndex) {
            return this._file.getFile(this._nodeList.item(aIndex));
        };
        // -------------------------------------------------------------------------
        NodeListXml.prototype.getEntity = function (aIndex) {
            return this._file.getEntity(this._nodeList.item(aIndex));
        };
        // -------------------------------------------------------------------------
        NodeListXml.prototype.getObjectInfo = function (aIndex) {
            return this._file.getObjectInfo(this._nodeList.item(aIndex), aIndex);
        };
        // -------------------------------------------------------------------------
        NodeListXml.prototype.getAnimation = function (aIndex) {
            return this._file.getAnimation(this._nodeList.item(aIndex));
        };
        // -------------------------------------------------------------------------
        NodeListXml.prototype.getMainLineKey = function (aIndex) {
            return this._file.getMainLineKey(this._nodeList.item(aIndex));
        };
        // -------------------------------------------------------------------------
        NodeListXml.prototype.getRef = function (aIndex) {
            return this._file.getRef(this._nodeList.item(aIndex));
        };
        // -------------------------------------------------------------------------
        NodeListXml.prototype.getTimeline = function (aIndex) {
            return this._file.getTimeline(this._nodeList.item(aIndex));
        };
        // -------------------------------------------------------------------------
        NodeListXml.prototype.getTimelineKey = function (aIndex, aSpriter) {
            return this._file.getTimelineKey(this._nodeList.item(aIndex), aIndex, aSpriter);
        };
        return NodeListXml;
    })();
    Spriter.NodeListXml = NodeListXml;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=NodeListXml.js.map
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
///<reference path="LoaderSpriterFile.ts"/>
///<reference path="NodeListJSON.ts"/>
///<reference path="../Structure/BoneTimelineKey.ts"/>
var Spriter;
(function (Spriter) {
    var SpriterJSON = (function (_super) {
        __extends(SpriterJSON, _super);
        // -------------------------------------------------------------------------
        function SpriterJSON(aJSONData, aMinDefs) {
            if (aMinDefs === void 0) { aMinDefs = null; }
            _super.call(this);
            this._json = aJSONData;
            var minimized = aJSONData["min"] !== undefined;
            this.setMinimized(minimized, aMinDefs);
        }
        // -------------------------------------------------------------------------
        SpriterJSON.prototype.parseInt = function (aElement, aAttributeName, aDefaultValue) {
            if (aDefaultValue === void 0) { aDefaultValue = 0; }
            var value = aElement[this.translateAttributeName(aAttributeName)];
            if (value === undefined) {
                return aDefaultValue;
            }
            return typeof (value) === "number" ? value : parseInt(value);
        };
        // -------------------------------------------------------------------------
        SpriterJSON.prototype.parseFloat = function (aElement, aAttributeName, aDefaultValue) {
            if (aDefaultValue === void 0) { aDefaultValue = 0; }
            var value = aElement[this.translateAttributeName(aAttributeName)];
            if (value === undefined) {
                return aDefaultValue;
            }
            return typeof (value) === "number" ? value : parseFloat(value);
        };
        // -------------------------------------------------------------------------
        SpriterJSON.prototype.parseBoolean = function (aElement, aAttributeName, aDefaultValue) {
            if (aDefaultValue === void 0) { aDefaultValue = false; }
            var value = aElement[this.translateAttributeName(aAttributeName)];
            if (value === undefined) {
                return aDefaultValue;
            }
            return typeof (value) === "boolean" ? value : (value === "true");
        };
        // -------------------------------------------------------------------------
        SpriterJSON.prototype.parseString = function (aElement, aAttributeName, aDefaultValue) {
            if (aDefaultValue === void 0) { aDefaultValue = ""; }
            var value = aElement[this.translateAttributeName(aAttributeName)];
            return value === undefined ? aDefaultValue : value;
        };
        // -------------------------------------------------------------------------
        SpriterJSON.prototype.getNodes = function (aNodeName) {
            this.setMinDefsToElementName(aNodeName);
            var translatedName = this.translateElementName(aNodeName);
            return new Spriter.NodeListJSON(this, this._json[translatedName]);
        };
        // -------------------------------------------------------------------------
        SpriterJSON.prototype.getNodesForElement = function (aElement, aNodeName) {
            this.setMinDefsToElementName(aNodeName);
            var translatedName = this.translateElementName(aNodeName);
            return new Spriter.NodeListJSON(this, aElement[translatedName]);
        };
        // -------------------------------------------------------------------------
        SpriterJSON.prototype.getFolder = function (aElement) {
            return new Spriter.Folder(this.parseInt(aElement, "id"), this.parseString(aElement, "name"));
        };
        // -------------------------------------------------------------------------
        SpriterJSON.prototype.getFile = function (aElement) {
            return new Spriter.SpriterFile(this.parseInt(aElement, "id"), this.getFileNameWithoutExtension(this.parseString(aElement, "name")), this.parseFloat(aElement, "pivot_x"), 1 - this.parseFloat(aElement, "pivot_y"));
        };
        // -------------------------------------------------------------------------
        SpriterJSON.prototype.getEntity = function (aElement) {
            return new Spriter.Entity(this.parseInt(aElement, "id"), this.parseString(aElement, "name"));
        };
        // -------------------------------------------------------------------------
        SpriterJSON.prototype.getObjectInfo = function (aElement, aIndex) {
            return new Spriter.ObjectInfo(aIndex, this.parseString(aElement, "name"), Spriter.ObjectType.getObjectTypeForName(this.parseString(aElement, "type")), this.parseFloat(aElement, "w"), this.parseFloat(aElement, "h"));
        };
        // -------------------------------------------------------------------------
        SpriterJSON.prototype.getAnimation = function (aElement) {
            return new Spriter.Animation(this.parseInt(aElement, "id"), this.parseString(aElement, "name"), this.parseFloat(aElement, "length"), this.parseBoolean(aElement, "looping", true) === true ? Spriter.eAnimationLooping.LOOPING : Spriter.eAnimationLooping.NO_LOOPING);
        };
        // -------------------------------------------------------------------------
        SpriterJSON.prototype.getMainLineKey = function (aElement) {
            return new Spriter.MainLineKey(this.parseFloat(aElement, "time"));
        };
        // -------------------------------------------------------------------------
        SpriterJSON.prototype.getRef = function (aElement) {
            return new Spriter.Ref(this.parseInt(aElement, "id"), this.parseInt(aElement, "parent", -1), this.parseInt(aElement, "timeline"), this.parseInt(aElement, "key"), this.parseInt(aElement, "z_index"));
        };
        // -------------------------------------------------------------------------
        SpriterJSON.prototype.getTimeline = function (aElement) {
            return new Spriter.Timeline(this.parseInt(aElement, "id"), this.parseString(aElement, "name"), this.parseString(aElement, "object_type") === "bone" ? Spriter.eObjectType.BONE : Spriter.eObjectType.SPRITE, this.parseInt(aElement, "obj", -1));
        };
        // -------------------------------------------------------------------------
        SpriterJSON.prototype.getTimelineKey = function (aElement, aIndex, aSpriter) {
            var time = this.parseInt(aElement, "time");
            var spin = this.parseInt(aElement, "spin", 1);
            // curve and params
            var curve = this.parseString(aElement, "curve_type", "linear");
            var c1 = this.parseFloat(aElement, "c1", 0);
            var c2 = this.parseFloat(aElement, "c2", 0);
            var c3 = this.parseFloat(aElement, "c3", 0);
            var c4 = this.parseFloat(aElement, "c4", 0);
            // sprite or bone key?
            var boneTag = this.translateChildElementName("bone");
            var objectTag = this.translateChildElementName("object");
            var key = null;
            var keyDataElm = null;
            var sprite = false;
            if (aElement[boneTag] !== undefined) {
                keyDataElm = aElement[boneTag];
                key = new Spriter.BoneTimelineKey(aIndex, time, spin);
                this.setMinDefsToElementName("bone");
            }
            else if (aElement[objectTag] !== undefined) {
                keyDataElm = aElement[objectTag];
                key = new Spriter.ObjectTimelineKey(aIndex, time, spin);
                this.setMinDefsToElementName("object");
                sprite = true;
            }
            // other curve than linear?
            if (curve !== "linear") {
                key.setCurve(Spriter.CurveType.getCurveTypeForName(curve), c1, c2, c3, c4);
            }
            // spatial info
            var info = key.getInfo();
            info.x = this.parseFloat(keyDataElm, "x");
            info.y = -this.parseFloat(keyDataElm, "y");
            info.scaleX = this.parseFloat(keyDataElm, "scale_x", 1);
            info.scaleY = this.parseFloat(keyDataElm, "scale_y", 1);
            info.angle = 360 - this.parseFloat(keyDataElm, "angle");
            info.alpha = this.parseFloat(keyDataElm, "a", 1);
            if (sprite) {
                // sprite specific - set file and folder
                var folderId = this.parseInt(keyDataElm, "folder");
                var fileId = this.parseInt(keyDataElm, "file");
                key.setFolderAndFile(folderId, fileId);
                // set pivot in spatial info different from default (based on pivot in file)
                var file = aSpriter.getFolderById(folderId).getFileById(fileId);
                info.pivotX = this.parseFloat(keyDataElm, "pivot_x", file.getAnchorX());
                // 1 - to flip Y, default anchor is already flipped, so it needs to be flipped back to avoid double flipping
                info.pivotY = 1 - this.parseFloat(keyDataElm, "pivot_y", 1 - file.getAnchorY());
            }
            this.popMinDefsStack();
            return key;
        };
        return SpriterJSON;
    })(Spriter.LoaderSpriterFile);
    Spriter.SpriterJSON = SpriterJSON;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=SpriterJSON.js.map
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
///<reference path="LoaderSpriterFile.ts"/>
///<reference path="NodeListXml.ts"/>
///<reference path="../Structure/BoneTimelineKey.ts"/>
var Spriter;
(function (Spriter) {
    var SpriterXml = (function (_super) {
        __extends(SpriterXml, _super);
        // -------------------------------------------------------------------------
        function SpriterXml(aXmlData, aMinDefs) {
            if (aMinDefs === void 0) { aMinDefs = null; }
            _super.call(this);
            this._xml = aXmlData;
            var minimized = aXmlData.documentElement.hasAttribute("min");
            this.setMinimized(minimized, aMinDefs);
        }
        // -------------------------------------------------------------------------
        SpriterXml.prototype.parseInt = function (aElement, aAttributeName, aDefaultValue) {
            if (aDefaultValue === void 0) { aDefaultValue = 0; }
            var value = aElement.getAttribute(this.translateAttributeName(aAttributeName));
            return value !== null ? parseInt(value) : aDefaultValue;
        };
        // -------------------------------------------------------------------------
        SpriterXml.prototype.parseFloat = function (aElement, aAttributeName, aDefaultValue) {
            if (aDefaultValue === void 0) { aDefaultValue = 0; }
            var value = aElement.getAttribute(this.translateAttributeName(aAttributeName));
            return value !== null ? parseFloat(value) : aDefaultValue;
        };
        // -------------------------------------------------------------------------
        SpriterXml.prototype.parseString = function (aElement, aAttributeName, aDefaultValue) {
            if (aDefaultValue === void 0) { aDefaultValue = ""; }
            var value = aElement.getAttribute(this.translateAttributeName(aAttributeName));
            return value !== null ? value : aDefaultValue;
        };
        // -------------------------------------------------------------------------
        SpriterXml.prototype.getNodes = function (aNodeName) {
            this.setMinDefsToElementName(aNodeName);
            var translatedName = this.translateElementName(aNodeName);
            return new Spriter.NodeListXml(this, this._xml.documentElement.getElementsByTagName(translatedName));
        };
        // -------------------------------------------------------------------------
        SpriterXml.prototype.getNodesForElement = function (aElement, aNodeName) {
            this.setMinDefsToElementName(aNodeName);
            var translatedName = this.translateElementName(aNodeName);
            return new Spriter.NodeListXml(this, aElement.getElementsByTagName(translatedName));
        };
        // -------------------------------------------------------------------------
        SpriterXml.prototype.getFolder = function (aElement) {
            return new Spriter.Folder(this.parseInt(aElement, "id"), this.parseString(aElement, "name"));
        };
        // -------------------------------------------------------------------------
        SpriterXml.prototype.getFile = function (aElement) {
            return new Spriter.SpriterFile(this.parseInt(aElement, "id"), this.getFileNameWithoutExtension(this.parseString(aElement, "name")), this.parseFloat(aElement, "pivot_x"), 1 - this.parseFloat(aElement, "pivot_y"));
        };
        // -------------------------------------------------------------------------
        SpriterXml.prototype.getEntity = function (aElement) {
            return new Spriter.Entity(this.parseInt(aElement, "id"), this.parseString(aElement, "name"));
        };
        // -------------------------------------------------------------------------
        SpriterXml.prototype.getObjectInfo = function (aElement, aIndex) {
            return new Spriter.ObjectInfo(aIndex, this.parseString(aElement, "name"), Spriter.ObjectType.getObjectTypeForName(this.parseString(aElement, "type")), this.parseFloat(aElement, "w"), this.parseFloat(aElement, "h"));
        };
        // -------------------------------------------------------------------------
        SpriterXml.prototype.getAnimation = function (aElement) {
            return new Spriter.Animation(this.parseInt(aElement, "id"), this.parseString(aElement, "name"), this.parseFloat(aElement, "length"), this.parseString(aElement, "looping", "true") === "true" ? Spriter.eAnimationLooping.LOOPING : Spriter.eAnimationLooping.NO_LOOPING);
        };
        // -------------------------------------------------------------------------
        SpriterXml.prototype.getMainLineKey = function (aElement) {
            return new Spriter.MainLineKey(this.parseFloat(aElement, "time"));
        };
        // -------------------------------------------------------------------------
        SpriterXml.prototype.getRef = function (aElement) {
            return new Spriter.Ref(this.parseInt(aElement, "id"), this.parseInt(aElement, "parent", -1), this.parseInt(aElement, "timeline"), this.parseInt(aElement, "key"), this.parseInt(aElement, "z_index"));
        };
        // -------------------------------------------------------------------------
        SpriterXml.prototype.getTimeline = function (aElement) {
            return new Spriter.Timeline(this.parseInt(aElement, "id"), this.parseString(aElement, "name"), this.parseString(aElement, "object_type") === "bone" ? Spriter.eObjectType.BONE : Spriter.eObjectType.SPRITE, this.parseInt(aElement, "obj", -1));
        };
        // -------------------------------------------------------------------------
        SpriterXml.prototype.getTimelineKey = function (aElement, aIndex, aSpriter) {
            var time = this.parseInt(aElement, "time");
            var spin = this.parseInt(aElement, "spin", 1);
            // curve and params
            var curve = this.parseString(aElement, "curve_type", "linear");
            var c1 = this.parseFloat(aElement, "c1", 0);
            var c2 = this.parseFloat(aElement, "c2", 0);
            var c3 = this.parseFloat(aElement, "c3", 0);
            var c4 = this.parseFloat(aElement, "c4", 0);
            // sprite or bone key?
            var boneTag = this.translateChildElementName("bone");
            var objectTag = this.translateChildElementName("object");
            var key = null;
            var keyDataElm = (aElement.firstElementChild);
            var sprite = false;
            if (keyDataElm.tagName === boneTag) {
                key = new Spriter.BoneTimelineKey(aIndex, time, spin);
                this.setMinDefsToElementName("bone");
            }
            else if (keyDataElm.tagName === objectTag) {
                this.setMinDefsToElementName("object");
                key = new Spriter.ObjectTimelineKey(aIndex, time, spin);
                sprite = true;
            }
            // other curve than linear?
            if (curve !== "linear") {
                key.setCurve(Spriter.CurveType.getCurveTypeForName(curve), c1, c2, c3, c4);
            }
            // spatial info
            var info = key.getInfo();
            info.x = this.parseFloat(keyDataElm, "x");
            info.y = -this.parseFloat(keyDataElm, "y");
            info.scaleX = this.parseFloat(keyDataElm, "scale_x", 1);
            info.scaleY = this.parseFloat(keyDataElm, "scale_y", 1);
            info.angle = 360 - this.parseFloat(keyDataElm, "angle");
            info.alpha = this.parseFloat(keyDataElm, "a", 1);
            if (sprite) {
                // sprite specific - set file and folder
                var folderId = this.parseInt(keyDataElm, "folder");
                var fileId = this.parseInt(keyDataElm, "file");
                key.setFolderAndFile(folderId, fileId);
                // set pivot in spatial info different from default (based on pivot in file)
                var file = aSpriter.getFolderById(folderId).getFileById(fileId);
                info.pivotX = this.parseFloat(keyDataElm, "pivot_x", file.getAnchorX());
                // 1 - to flip Y, default anchor is already flipped, so it needs to be flipped back to avoid double flipping
                info.pivotY = 1 - this.parseFloat(keyDataElm, "pivot_y", 1 - file.getAnchorY());
            }
            this.popMinDefsStack();
            return key;
        };
        return SpriterXml;
    })(Spriter.LoaderSpriterFile);
    Spriter.SpriterXml = SpriterXml;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=SpriterXml.js.map
///<reference path="MainLineKey.ts"/>
///<reference path="../../Helpers/IdNameMap.ts"/>
///<reference path="Timeline.ts"/>
var Spriter;
(function (Spriter) {
    (function (eAnimationLooping) {
        eAnimationLooping[eAnimationLooping["NO_LOOPING"] = 0] = "NO_LOOPING";
        eAnimationLooping[eAnimationLooping["LOOPING"] = 1] = "LOOPING";
    })(Spriter.eAnimationLooping || (Spriter.eAnimationLooping = {}));
    var eAnimationLooping = Spriter.eAnimationLooping;
    ;
    var Animation = (function () {
        // -------------------------------------------------------------------------
        function Animation(aId, aName, aLength, aLoopType) {
            this._mainLineKeys = [];
            this._id = aId;
            this._name = aName;
            this._length = aLength;
            this._loopType = aLoopType;
            this._timelines = new Helper.IdNameMap();
        }
        // -------------------------------------------------------------------------
        Animation.prototype.getMainLineKeys = function () {
            return this._mainLineKeys;
        };
        // -------------------------------------------------------------------------
        Animation.prototype.addMainLineKey = function (aMainLineKey) {
            this._mainLineKeys.push(aMainLineKey);
        };
        // -------------------------------------------------------------------------
        Animation.prototype.addTimeline = function (aTimeline) {
            this._timelines.add(aTimeline, aTimeline.getId(), aTimeline.getName());
        };
        // -------------------------------------------------------------------------
        Animation.prototype.getTimelineById = function (aId) {
            return this._timelines.getById(aId);
        };
        // -------------------------------------------------------------------------
        Animation.prototype.getTimelineByName = function (aName) {
            return this._timelines.getByName(aName);
        };
        // -------------------------------------------------------------------------
        Animation.prototype.getId = function () {
            return this._id;
        };
        // -------------------------------------------------------------------------
        Animation.prototype.getName = function () {
            return this._name;
        };
        // -------------------------------------------------------------------------
        Animation.prototype.getLength = function () {
            return this._length;
        };
        // -------------------------------------------------------------------------
        Animation.prototype.getLoopType = function () {
            return this._loopType;
        };
        return Animation;
    })();
    Spriter.Animation = Animation;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=Animation.js.map
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
///<reference path="SpatialTimelineKey.ts"/>
var Spriter;
(function (Spriter) {
    var BoneTimelineKey = (function (_super) {
        __extends(BoneTimelineKey, _super);
        function BoneTimelineKey() {
            _super.apply(this, arguments);
        }
        return BoneTimelineKey;
    })(Spriter.SpatialTimelineKey);
    Spriter.BoneTimelineKey = BoneTimelineKey;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=BoneTimelineKey.js.map
var Spriter;
(function (Spriter) {
    (function (eCurveType) {
        eCurveType[eCurveType["LINEAR"] = 0] = "LINEAR";
        eCurveType[eCurveType["INSTANT"] = 1] = "INSTANT";
        eCurveType[eCurveType["QUADRATIC"] = 2] = "QUADRATIC";
        eCurveType[eCurveType["CUBIC"] = 3] = "CUBIC";
    })(Spriter.eCurveType || (Spriter.eCurveType = {}));
    var eCurveType = Spriter.eCurveType;
    ;
    var CurveType = (function () {
        function CurveType() {
        }
        // -------------------------------------------------------------------------
        CurveType.getCurveTypeForName = function (aCurveTypeName) {
            if (aCurveTypeName === "linear") {
                return eCurveType.LINEAR;
            }
            else if (aCurveTypeName === "instant") {
                return eCurveType.INSTANT;
            }
            else if (aCurveTypeName === "quadratic") {
                return eCurveType.QUADRATIC;
            }
            else if (aCurveTypeName === "cubic") {
                return eCurveType.CUBIC;
            }
            else {
                console.warn("Unknown curve type: " + aCurveTypeName);
            }
        };
        return CurveType;
    })();
    Spriter.CurveType = CurveType;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=CurveType.js.map
///<reference path="../../Helpers/IdNameMap.ts"/>
///<reference path="ObjectInfo.ts"/>
///<reference path="Animation.ts"/>
var Spriter;
(function (Spriter) {
    var Entity = (function () {
        // -------------------------------------------------------------------------
        function Entity(aId, aName) {
            this._id = aId;
            this._name = aName;
            this._objectInfos = new Helper.IdNameMap();
            this._animations = new Helper.IdNameMap();
        }
        // -------------------------------------------------------------------------
        Entity.prototype.addObjectInfo = function (aObjectInfo) {
            this._objectInfos.add(aObjectInfo, aObjectInfo.getId(), aObjectInfo.getName());
        };
        // -------------------------------------------------------------------------
        Entity.prototype.getObjectInfoById = function (aId) {
            return this._objectInfos.getById(aId);
        };
        // -------------------------------------------------------------------------
        Entity.prototype.getObjectInfoByName = function (aName) {
            return this._objectInfos.getByName(aName);
        };
        // -------------------------------------------------------------------------
        Entity.prototype.addAnimation = function (aAnimation) {
            this._animations.add(aAnimation, aAnimation.getId(), aAnimation.getName());
        };
        // -------------------------------------------------------------------------
        Entity.prototype.getAnimationById = function (aId) {
            return this._animations.getById(aId);
        };
        // -------------------------------------------------------------------------
        Entity.prototype.getAnimationByName = function (aName) {
            return this._animations.getByName(aName);
        };
        // -------------------------------------------------------------------------
        Entity.prototype.getAnimationsCount = function () {
            return this._animations.getLength();
        };
        // -------------------------------------------------------------------------
        Entity.prototype.getId = function () {
            return this._id;
        };
        // -------------------------------------------------------------------------
        Entity.prototype.getName = function () {
            return this._name;
        };
        return Entity;
    })();
    Spriter.Entity = Entity;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=Entity.js.map
///<reference path="../../Helpers/IdNameMap.ts"/>
///<reference path="SpriterFile.ts"/>
var Spriter;
(function (Spriter) {
    var Folder = (function () {
        // -------------------------------------------------------------------------
        function Folder(aId, aName) {
            this._id = aId;
            this._name = aName;
            this._files = new Helper.IdNameMap();
        }
        // -------------------------------------------------------------------------
        Folder.prototype.addFile = function (aFile) {
            this._files.add(aFile, aFile.getId(), aFile.getName());
        };
        // -------------------------------------------------------------------------
        Folder.prototype.getFileById = function (aId) {
            return this._files.getById(aId);
        };
        // -------------------------------------------------------------------------
        Folder.prototype.getFileByName = function (aName) {
            return this._files.getByName(aName);
        };
        // -------------------------------------------------------------------------
        Folder.prototype.getId = function () {
            return this._id;
        };
        // -------------------------------------------------------------------------
        Folder.prototype.getName = function () {
            return this._name;
        };
        return Folder;
    })();
    Spriter.Folder = Folder;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=Folder.js.map
///<reference path="Ref.ts"/>
var Spriter;
(function (Spriter) {
    var MainLineKey = (function () {
        // -------------------------------------------------------------------------
        function MainLineKey(aTime) {
            this._boneRefs = [];
            this._objectRefs = [];
            this._time = aTime;
        }
        // -------------------------------------------------------------------------
        MainLineKey.prototype.getBoneRefs = function () {
            return this._boneRefs;
        };
        // -------------------------------------------------------------------------
        MainLineKey.prototype.addBoneRef = function (aBoneRef) {
            this._boneRefs.push(aBoneRef);
        };
        // -------------------------------------------------------------------------
        MainLineKey.prototype.getObjectRefs = function () {
            return this._objectRefs;
        };
        // -------------------------------------------------------------------------
        MainLineKey.prototype.addObjectRef = function (aObjectRef) {
            this._objectRefs.push(aObjectRef);
        };
        // -------------------------------------------------------------------------
        MainLineKey.prototype.getTime = function () {
            return this._time;
        };
        return MainLineKey;
    })();
    Spriter.MainLineKey = MainLineKey;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=MainLineKey.js.map
///<reference path="ObjectType.ts"/>
var Spriter;
(function (Spriter) {
    var ObjectInfo = (function () {
        // -------------------------------------------------------------------------
        function ObjectInfo(aId, aName, aType, aWidth, aHeight) {
            this._id = aId;
            this._type = aType;
            this._name = aName;
            this._width = aWidth;
            this._height = aHeight;
        }
        // -------------------------------------------------------------------------
        ObjectInfo.prototype.getId = function () {
            return this._id;
        };
        // -------------------------------------------------------------------------
        ObjectInfo.prototype.getType = function () {
            return this._type;
        };
        // -------------------------------------------------------------------------
        ObjectInfo.prototype.getName = function () {
            return this._name;
        };
        // -------------------------------------------------------------------------
        ObjectInfo.prototype.getWidth = function () {
            return this._width;
        };
        // -------------------------------------------------------------------------
        ObjectInfo.prototype.getHeight = function () {
            return this._height;
        };
        return ObjectInfo;
    })();
    Spriter.ObjectInfo = ObjectInfo;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=ObjectInfo.js.map
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
///<reference path="SpatialTimelineKey.ts"/>
var Spriter;
(function (Spriter) {
    var ObjectTimelineKey = (function (_super) {
        __extends(ObjectTimelineKey, _super);
        function ObjectTimelineKey() {
            _super.apply(this, arguments);
        }
        // -------------------------------------------------------------------------
        ObjectTimelineKey.prototype.setFolderAndFile = function (aFolder, aFile) {
            this._folder = aFolder;
            this._file = aFile;
        };
        // -------------------------------------------------------------------------
        ObjectTimelineKey.prototype.getFolder = function () {
            return this._folder;
        };
        // -------------------------------------------------------------------------
        ObjectTimelineKey.prototype.getFile = function () {
            return this._file;
        };
        return ObjectTimelineKey;
    })(Spriter.SpatialTimelineKey);
    Spriter.ObjectTimelineKey = ObjectTimelineKey;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=ObjectTimelineKey.js.map
var Spriter;
(function (Spriter) {
    (function (eObjectType) {
        eObjectType[eObjectType["SPRITE"] = 0] = "SPRITE";
        eObjectType[eObjectType["BONE"] = 1] = "BONE"; /*, BOX, POINT, SOUND, ENTITY, VARIABLE */
    })(Spriter.eObjectType || (Spriter.eObjectType = {}));
    var eObjectType = Spriter.eObjectType;
    ;
    var ObjectType = (function () {
        function ObjectType() {
        }
        // -------------------------------------------------------------------------
        ObjectType.getObjectTypeForName = function (aTypeName) {
            if (aTypeName === "sprite") {
                return eObjectType.SPRITE;
            }
            else if (aTypeName === "bone") {
                return eObjectType.BONE;
            }
        };
        return ObjectType;
    })();
    Spriter.ObjectType = ObjectType;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=ObjectType.js.map
var Spriter;
(function (Spriter) {
    var Ref = (function () {
        // -------------------------------------------------------------------------
        function Ref(aId, aParent, aTimeline, aKey, aZ) {
            if (aZ === void 0) { aZ = 0; }
            this.id = aId;
            this.parent = aParent;
            this.timeline = aTimeline;
            this.key = aKey;
            this.z = aZ;
        }
        return Ref;
    })();
    Spriter.Ref = Ref;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=Ref.js.map
var Spriter;
(function (Spriter) {
    var SpatialInfo = (function () {
        function SpatialInfo() {
            this.x = 0;
            this.y = 0;
            this.scaleX = 1;
            this.scaleY = 1;
            this.pivotX = 0;
            this.pivotY = 0;
            this.alpha = 1;
            this.angle = 0;
        }
        return SpatialInfo;
    })();
    Spriter.SpatialInfo = SpatialInfo;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=SpatialInfo.js.map
var Spriter;
(function (Spriter) {
    var SpriterFile = (function () {
        // -------------------------------------------------------------------------
        function SpriterFile(aId, aName, aAnchorX, aAnchorY) {
            this._id = aId;
            this._name = aName;
            this._anchorX = aAnchorX;
            this._anchorY = aAnchorY;
        }
        // -------------------------------------------------------------------------
        SpriterFile.prototype.getId = function () {
            return this._id;
        };
        // -------------------------------------------------------------------------
        SpriterFile.prototype.getName = function () {
            return this._name;
        };
        // -------------------------------------------------------------------------
        SpriterFile.prototype.getAnchorX = function () {
            return this._anchorX;
        };
        // -------------------------------------------------------------------------
        SpriterFile.prototype.getAnchorY = function () {
            return this._anchorY;
        };
        return SpriterFile;
    })();
    Spriter.SpriterFile = SpriterFile;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=SpriterFile.js.map
///<reference path="ObjectType.ts"/>
///<reference path="TimelineKey.ts"/>
var Spriter;
(function (Spriter) {
    var Timeline = (function () {
        // -------------------------------------------------------------------------
        function Timeline(aId, aName, aType, aObjectRef) {
            if (aType === void 0) { aType = Spriter.eObjectType.SPRITE; }
            if (aObjectRef === void 0) { aObjectRef = -1; }
            this._keys = [];
            this._id = aId;
            this._name = aName;
            this._type = aType;
            this._objectRef = aObjectRef;
        }
        // -------------------------------------------------------------------------
        Timeline.prototype.getKeys = function () {
            return this._keys;
        };
        // -------------------------------------------------------------------------
        Timeline.prototype.addKey = function (aKey) {
            this._keys.push(aKey);
        };
        // -------------------------------------------------------------------------
        Timeline.prototype.getId = function () {
            return this._id;
        };
        // -------------------------------------------------------------------------
        Timeline.prototype.getName = function () {
            return this._name;
        };
        // -------------------------------------------------------------------------
        Timeline.prototype.getType = function () {
            return this._type;
        };
        // -------------------------------------------------------------------------
        Timeline.prototype.getObjectRef = function () {
            return this._objectRef;
        };
        return Timeline;
    })();
    Spriter.Timeline = Timeline;
})(Spriter || (Spriter = {}));
//# sourceMappingURL=Timeline.js.map