/// <reference path="lib/ts/phaser.d.ts" />
/// <reference path="lib/ts/spriterRuntime.d.ts" />
/// <reference path="spriterObj.ts" />
/// <reference path="Dog.ts" />
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Sheep = (function (_super) {
    __extends(Sheep, _super);
    function Sheep(textureKey, game, sheepData, x, y) {
        _super.call(this, textureKey, "sheep", "idle", game, sheepData, x, y);
        this.counted = false;
        this.vec = new Phaser.Point(0, 0);
        this.speedDecay = 5;
        this.lastBark = 0;
        this.standingSince = 0;
        this.turnDelay = 30;
        this.spriterGroup.setAnimationSpeedPercent(75 + Math.random() * 50);
    }
    Sheep.createSheep = function (game, sheepData, x, y) {
        var texture = "sheep";
        if (Math.random() < 0.5) {
            texture = "sheep2";
        }
        return new Sheep(texture, game, sheepData, x, y);
    };
    Sheep.prototype.updateAI = function (tick, allSheeps, dog, sound) {
        if (!this.standing && Math.abs(this.speed.getMagnitude()) < 0.01) {
            this.standing = true;
            this.standingSince = tick;
            this.speedDecay = 1;
        }
        if (tick % this.speedDecay == 0) {
            this.speed.multiply(0.9, 0.9);
        }
        for (var i = 0; i < allSheeps.length; i++) {
            if (allSheeps[i] != this) {
                var dist = allSheeps[i].distanceTo(this);
                if (dist < 150) {
                    this.vec.set(allSheeps[i].getPos().x - this.getPos().x, allSheeps[i].getPos().y - this.getPos().y);
                    this.vec.multiply(-1, -1);
                    this.vec.normalize();
                    var need = 0;
                    if (dist < 75) {
                        need = Math.max(1, allSheeps[i].speed.getMagnitude());
                    }
                    else {
                        need = Math.max(1, allSheeps[i].speed.getMagnitude()) * (150 - dist) / 100;
                    }
                    this.vec.multiply(need, need);
                    this.speed.add(this.vec.x, this.vec.y);
                }
            }
        }
        var dist = dog.distanceTo(this);
        if (dist < 250) {
            if (this.standing && tick - this.lastBark > 300) {
                this.lastBark = tick;
                var rnd = Math.random();
                if (rnd > 0.66) {
                    sound.play('ba1');
                }
                else if (rnd > 0.33) {
                    sound.play('ba2');
                }
                else {
                    sound.play('ba3');
                }
            }
            this.vec.set(dog.getPos().x - this.getPos().x, dog.getPos().y - this.getPos().y);
            this.vec.multiply(-1, -1);
            this.vec.normalize();
            var need = 0;
            if (dist < 10) {
                need = 8;
                //hund ist so dich dran, dass wir wohl in der ecke stehen.. richtung zufällig wählen:
                var rnd = Math.random();
                if (rnd > 0.75) {
                    this.vec.set(0.5, 0.5);
                }
                else if (rnd > 0.5) {
                    this.vec.set(0.5, -0.5);
                }
                else if (rnd > 0.25) {
                    this.vec.set(-0.5, 0.5);
                }
                else {
                    this.vec.set(-0.5, -0.5);
                }
            }
            else if (dist < 150) {
                need = Math.max(3, dog.speed.getMagnitude());
            }
            else {
                need = Math.max(1, dog.speed.getMagnitude()) * (250 - dist) / 100;
            }
            this.vec.multiply(need, need);
            this.speed.add(this.vec.x, this.vec.y);
            if (dog.isBarking()) {
                this.speedDecay = 20;
            }
            else {
                this.speedDecay = Math.max(this.speedDecay, 5);
            }
        }
        else if (dog.isBarking() && dist < 800) {
            if (dist < 500 && this.standing && tick - this.lastBark > 300) {
                this.lastBark = tick;
                var rnd = Math.random();
                if (rnd > 0.66) {
                    sound.play('ba1');
                }
                else if (rnd > 0.33) {
                    sound.play('ba2');
                }
                else {
                    sound.play('ba3');
                }
            }
            this.speedDecay = 20;
            this.vec.set(dog.getPos().x - this.getPos().x, dog.getPos().y - this.getPos().y);
            this.vec.multiply(-1, -1);
            this.vec.normalize();
            this.vec.multiply(8, 8);
            this.speed.add(this.vec.x, this.vec.y);
        }
        if (this.standing && tick - this.standingSince > 600) {
            if (Math.random() < 0.01) {
                this.speed.add(0.5 - Math.random(), 0.5 - Math.random());
                var rnd = Math.random() * 4;
                this.speed.multiply(rnd, rnd);
                this.speedDecay = 5;
            }
        }
    };
    Sheep.prototype.calcAnimation = function (tick) {
        //noinspection JSSuspiciousNameCombination
        if (this.speed.getMagnitude() > 5) {
            this.setAnimation("run");
        }
        else if (this.speed.getMagnitude() > 0.5) {
            if (this.spriterGroup.getCurrentAnimationName() != "run" || this.speed.getMagnitude() < 3) {
                this.setAnimation("walk");
            }
        }
        else {
            this.setAnimation("idle");
        }
    };
    return Sheep;
})(SpriterObj);
//# sourceMappingURL=sheep.js.map